﻿#include"PacMan.h"

//Создание игрового поля, начало счетчика и времени
PacMan::PacMan(Board& board) : m_board(board)
{
}

//Движение пакмена в зависимости от нажатой клавиши
void PacMan::move()
{
    static int old = 0;
    Sleep(120);

    if (_kbhit())
    {
        int moving = _getch();

        if (moving == 0 || moving == 224)
        {
            switch (_getch())
            {
                //Движение пакмена вверх
            case 72: 
            {
                char field = m_board.m_board[coordY - 1][coordX];
                if (old == 75 && field != ' ' && field != '.') { moveLeft(); break; }
                else if (old == 77 && field != ' ' && field != '.') { moveRight(); break; }
                moveUp();
                old = 72;
                break;
            }
                //Движение пакмена влево
            case 75:
            {
                if (coordX != 0)
                {
                    char field = m_board.m_board[coordY][coordX - 1];
                    if (old == 72 && field != ' ' && field != '.') { moveUp(); break; }
                    else if (old == 80 && field != ' ' && field != '.') { moveDown(); break; }
                }
                moveLeft();
                old = 75;
                break;
            }
                //Движение пакмена вправо
            case 77:
            {
                if (coordX != 48)
                {
                    char field = m_board.m_board[coordY][coordX + 1];
                    if (old == 72 && field != ' ' && field != '.') { moveUp(); break; }
                    else if (old == 80 && field != ' ' && field != '.') { moveDown(); break; }
                }
                moveRight();
                old = 77;
                break;
            }
                //Движение пакмена вниз
            case 80:
            {
                char field = m_board.m_board[coordY + 1][coordX];
                if (old == 75 && field != ' ' && field != '.') { moveLeft(); break; }
                else if (old == 77 && field != ' ' && field != '.') { moveRight(); break; }
                moveDown();
                old = 80;
                break;
            }
            }
        }
    }
    else
    {
        switch (old)
        {
        //Движение пакмена вверх
        case 72: moveUp();    break;
        //Движение пакмена влево
        case 75: moveLeft();  break;
        //Движение пакмена вправо
        case 77: moveRight(); break;
        //Движение пакмена вниз
        case 80: moveDown();  break;
        }
    }

    updateScore();
}

void PacMan::update()
{
    if (m_board.getCountDots() == 0)
    {
        Sleep(100);

        m_board.update();

        SetCoordCursor(0, 0);
        m_board.print();

        m_level++;
    }

    dots = 0;

    coordX = 24;
    coordY = 13;

    SetCoordCursor(20, 20);
    SetColor(Yellow, Black);
    for (int i = 0; i < m_health; i++) std::cout << 'O';
    std::cout << "   ";

    SetCoordCursor(45, 20);
    SetColor(LightGray, Black);
    std::cout << m_level;
}

//Движение пакмена вверх
void PacMan::moveUp()
{
    char field = m_board.m_board[coordY - 1][coordX];

    if (field == '.' || field == ' ')
    {
        coordY--;

        if (field == '.')
        {
            m_board.m_board[coordY][coordX] = ' ';
            m_board.countDots--;
            m_score += 10;
            dots++;
        }

        SetCoordCursor(coordX + 4, coordY + 4);
        std::cout << ' ';

        SetCoordCursor(coordX + 4, coordY + 3);
        SetColor(Yellow, Black);
        std::cout << 'O';
    }
}

//Движение пакмена влево
void PacMan::moveLeft()
{
    if (coordX != 0)
    {
        char field = m_board.m_board[coordY][coordX - 1];

        if (field == '.' || field == ' ')
        {
            coordX--;

            if (field == '.')
            {
                m_board.m_board[coordY][coordX] = ' ';
                m_board.countDots--;
                m_score += 10;
                dots++;
            }

            SetCoordCursor(coordX + 5, coordY + 3);
            std::cout << ' ';

            SetCoordCursor(coordX + 4, coordY + 3);
            SetColor(Yellow, Black);
            std::cout << 'O';
        }
    }
    else
    {
        coordX = 48;

        SetCoordCursor(4, coordY + 3);
        std::cout << ' ';

        SetCoordCursor(52, coordY + 3);
        SetColor(Yellow, Black);
        std::cout << 'O';
    }
}

//Движение пакмена вправо
void PacMan::moveRight()
{
    if (coordX != 48)
    {
        char field = m_board.m_board[coordY][coordX + 1];

        if (field == '.' || field == ' ')
        {
            coordX++;

            if (field == '.')
            {
                m_board.m_board[coordY][coordX] = ' ';
                m_board.countDots--;
                m_score += 10;
                dots++;
            }

            SetCoordCursor(coordX + 3, coordY + 3);
            std::cout << ' ';

            SetCoordCursor(coordX + 4, coordY + 3);
            SetColor(Yellow, Black);
            std::cout << 'O';
        }
    }
    else
    {
        coordX = 0;

        SetCoordCursor(52, coordY + 3);
        std::cout << ' ';

        SetCoordCursor(4, coordY + 3);
        SetColor(Yellow, Black);
        std::cout << 'O';
    }
}

//Движение пакмена вниз
void PacMan::moveDown()
{
    char field = m_board.m_board[coordY + 1][coordX];

    if (field == '.' || field == ' ')
    {
        coordY++;

        if (field == '.')
        {
            m_board.m_board[coordY][coordX] = ' ';
            m_board.countDots--;
            m_score += 10;
            dots++;
        }

        SetCoordCursor(coordX + 4, coordY + 2);
        std::cout << ' ';

        SetCoordCursor(coordX + 4, coordY + 3);
        SetColor(Yellow, Black);
        std::cout << 'O';
    }
}

//Обновление счетчика очков
void PacMan::updateScore()
{
    //Количество разрядов числа
    int count = 0;
    //Копия количества очков, необходима для того, чтобы значение не сбрасывалось
    int copy = m_score;

    std::array<char, 7> score{ 0 };

    while (copy != 0)
    {
        int lastDigit = copy % 10;
        score[count] = static_cast<char>(48 + lastDigit);
        copy /= 10;
        count++;
    }

    for (int i = 0; i < 7; i++)
    {
        SetColor(LightGray, Black);
        SetCoordCursor(34 - i, 3);
        std::cout << score[i];
    }
}